/*
  KEYPAD DATA 
  1=MENU
  2=UP
  3=DN
  4=QUIT
  AFTER POWER UP CLOCK WILL NOT START DIRECTLY
  PRESSING UP+DN KEYS TOGETHER  TO START CLOCK (UP=2,DN=3)
  PRESSING MENU KEY TAKES TO TIME ADJUST MENU (1= MENU)  
  PRESSING QUIT LEAVES FROM RUNNING CLOCK AND POINTS TO TIME ADJUST MENU (4 = QUIT)
  


    
*/
#include <LCD_I2C.h>
#include <Wire.h>
#include <I2C_RTC.h>
static DS3231 RTC;

int menu=0;
int updn=0;
//int dn=0;
int quit=0;
//
LCD_I2C lcd(0x27, 16, 2); // Default address of most PCF8574 modules, change according


void setup() {
  //start serial connection
  Serial.begin(9600);
  //configure pin 2 as an input and enable the internal pull-up resistor
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(13, OUTPUT);
  lcd.begin(); // If you are using more I2C devices using the Wire library use lcd.begin(false)
  lcd.backlight();
  //
  RTC.begin();
  //RTC.setHourMode(CLOCK_H12);
  RTC.setHourMode(CLOCK_H24);
  if (RTC.getHourMode() == CLOCK_H12)
  {
    //RTC.setMeridiem(HOUR_PM);
  }
  RTC.setDay(22);
  RTC.setMonth(5);
  RTC.setYear(2020);
  RTC.setHours(23);
  RTC.setMinutes(47);
  RTC.setSeconds(56);
  RTC.setWeek(1);

  //RTC.setDate(22,07,29);
  //RTC.setTime(22,10,20);
lcd.setCursor(3, 0);
      lcd.print("UP+DN CLOCK"); // You can make spaces using well... spaces
      lcd.setCursor(3, 1); // Or setting the cursor in the desired position.
      lcd.print("MENU TO ADJ"); 
      delay(1000);
  
}

void loop() {
  //read the pushbutton value into a variable
  int sensorVal1 = digitalRead(2);
  int sensorVal2 = digitalRead(3);
  int sensorVal3 = digitalRead(4);
  int sensorVal4 = digitalRead(5);
  
  //print out the value of the pushbutton
  //Serial.println(sensorVal);

  // Keep in mind the pull-up means the pushbutton's logic is inverted. It goes
  // HIGH when it's open, and LOW when it's pressed. Turn on pin 13 when the
  // button's pressed, and off when it's not:

  while ((sensorVal2) == LOW  && (sensorVal3) == LOW)
      {
        lcd.clear();
       mainclockdisplay();
    }
      
  if (sensorVal1 == HIGH) {
    digitalWrite(13, LOW);
  } else {
    digitalWrite(13, HIGH);
    if(menu<10){
    menu=menu+1;
    Serial.println("MENU");
    Serial.println(menu);
    delay(1000);
    }else{menu=1;}
  }


  //lcd.clear();
  switch (menu) {
    case 1:
    lcd.clear();    
    lcd.setCursor(0, 0);
      lcd.print("SET 12=1/24=0 HR"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getHourMode());
      updn=RTC.getHourMode();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<5){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<5){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(0, 0);
      lcd.print("SET 12=1/24=0 HR"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setHourMode(updn);
      lcd.print(RTC.getHourMode());
     // updn=RTC.getHours();
      delay(500);
      break; 
      case 2:
      lcd.clear();
      lcd.setCursor(5, 0);
      lcd.print("SET AM/PM"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getMeridiem());
      updn=RTC.getMeridiem();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<5){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<5){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET AM/PM"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setMeridiem(updn);
      lcd.print(RTC.getMeridiem());
     // updn=RTC.getHours();
      delay(500);
      break; 
    case 3:  // your hand is on the sensor
      lcd.clear();
      lcd.setCursor(5, 0);
      lcd.print("SET HOUR"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getHours());
      updn=RTC.getHours();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<59){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<59){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET HOUR"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setHours(updn);
      lcd.print(RTC.getHours());
     // updn=RTC.getHours();
      delay(500);
      break;
    case 4:  // your hand is close to the sensor
      lcd.clear();
      lcd.setCursor(5, 0);
      lcd.print("SET MINUITE"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getMinutes());
      updn=RTC.getMinutes();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<59){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<59){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET MINUITE"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setMinutes(updn);
      lcd.print(RTC.getMinutes());
     // updn=RTC.getHours();
      delay(500);
      break;
    case 5:  // your hand is a few inches from the sensor
    lcd.clear();
    lcd.setCursor(5, 0);
      lcd.print("SET DAY"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getDay());
      updn=RTC.getDay();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<59){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<59){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET DAY"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setDay(updn);
      lcd.print(RTC.getDay());
     // updn=RTC.getHours();
      delay(500);
      break;  
    case 6:  // your hand is nowhere near the sensor
      lcd.clear();
      lcd.setCursor(5, 0);
      lcd.print("SET MONTH"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getMonth());
      updn=RTC.getMonth();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<59){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<59){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET MONTH"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setMonth(updn);
      lcd.print(RTC.getMonth());
     // updn=RTC.getHours();
      delay(500);
      break;
    case 7:  // your hand is nowhere near the sensor
      lcd.clear();
      lcd.setCursor(5, 0);
      lcd.print("SET YEAR"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getYear());
      updn=RTC.getYear();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<9999){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<9999){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET YEAR"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setYear(updn);
      lcd.print(RTC.getYear());
     // updn=RTC.getHours();
      delay(500);
      break;
    case 8:  // your hand is nowhere near the sensor
      lcd.clear();
      lcd.setCursor(5, 0);
      lcd.print("SET WEEK"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      lcd.print(RTC.getWeek());
      updn=RTC.getWeek();
      //dn=RTC.getHours();
      if (sensorVal2 == HIGH) {
          digitalWrite(13, LOW);
            } else {
          digitalWrite(13, HIGH);
          if(updn<59){
             updn=updn+1;
             Serial.println("UP");
             Serial.println(updn);
             delay(1000);
            }else{updn=0;}
      }
      if (sensorVal3 == HIGH) {
            digitalWrite(13, LOW);
            } else {
            digitalWrite(13, HIGH);
            if(updn<59){
            updn=updn-1;
            Serial.println("DN");
            Serial.println(updn);
            delay(1000);
            }else{updn=0;}
      }  
      lcd.setCursor(5, 0);
      lcd.print("SET WEEK"); // You can make spaces using well... spaces
      lcd.setCursor(5, 1); // Or setting the cursor in the desired position.
      RTC.setWeek(updn);
      lcd.print(RTC.getWeek());
     // updn=RTC.getHours();
      delay(500);
      break; 
     
      case 9:  // your hand is nowhere near the sensor
      lcd.clear();      
      lcd.setCursor(1, 0);
      lcd.print("PRESS UP DN KEYS"); // You can make spaces using well... spaces
      lcd.setCursor(1, 1); // Or setting the cursor in the desired position.
      lcd.print("TO EXIT MENU"); 
      delay(500);
     while ((sensorVal2) == LOW  && (sensorVal3) == LOW)
      {
        mainclockdisplay();
      }
      break;

  }
  delay(1);  // delay in between reads for stability
  
  
}

void mainclockdisplay()

{

  int sensorVal1 = digitalRead(2);
  int sensorVal2 = digitalRead(3);
  int sensorVal3 = digitalRead(4);
  int sensorVal4 = digitalRead(5);


#define HOUR_AM 0
#define HOUR_PM 1

  switch (RTC.getWeek())
  {
    case 1:
      Serial.print("SUN");
      lcd.setCursor(13, 1);
      lcd.print("SUN");
      break;
    case 2:
      Serial.print("MON");
      lcd.setCursor(13, 1);
      lcd.print("MON");      
      break;
    case 3:
      Serial.print("TUE");
      lcd.setCursor(13, 1);
      lcd.print("TUE");      
      break;
    case 4:
      Serial.print("WED");
      lcd.setCursor(13, 1);
      lcd.print("WED");
      break;
    case 5:
      Serial.print("THU");
      lcd.setCursor(13, 1);
      lcd.print("THU");
      break;
    case 6:
      Serial.print("FRI");
      lcd.setCursor(13, 1);
      lcd.print("FRI");
      break;
    case 7:
      Serial.print("SAT");
      lcd.setCursor(13, 1);
      lcd.print("SAT");
      break;
  }
  Serial.print(" ");
  Serial.print(RTC.getDay());
  Serial.print("-");
  Serial.print(RTC.getMonth());
  Serial.print("-");
  Serial.print(RTC.getYear());

  Serial.print(" ");

  Serial.print(RTC.getHours());
  Serial.print(":");
  Serial.print(RTC.getMinutes());
  Serial.print(":");
  Serial.print(RTC.getSeconds());
  Serial.print(" ");
  Serial.println(RTC.getMeridiem());
  Serial.print(" ");

  if (RTC.getHourMode() == CLOCK_H12)
  {
    if(RTC.getMeridiem() == HOUR_AM)
    {
      Serial.println(" AM");
      lcd.setCursor(10, 1);
      lcd.print("AM");
    }
    else 
    {
     // (RTC.getMeridiem() == HOUR_PM)
      Serial.println(" PM");   
      lcd.setCursor(10, 1);
      lcd.print("PM");  
    }
  }

  Serial.print(RTC.getTemp());
  Serial.print(" ");
  lcd.setCursor(11, 0);
      lcd.print(RTC.getTemp()); 
      lcd.setCursor(15, 0);
      lcd.print("C"); 

  //delay(100);
  lcd.setCursor(0, 0);
  if(RTC.getDay()<10){
  lcd.print("0");
  lcd.print(RTC.getDay()); // You can make spaces using well... spaces
  } else {
   lcd.print(RTC.getDay()); // You can make spaces using well... spaces 
  }
  lcd.setCursor(2, 0);
  lcd.print("/");
  lcd.setCursor(3, 0);
  if(RTC.getMonth()<10){
  lcd.print("0");  
  lcd.print(RTC.getMonth()); // You can make spaces using well... spaces    
  }
  else {
  lcd.print(RTC.getMonth()); // You can make spaces using well... spaces
  }
    
  lcd.setCursor(5, 0);
  lcd.print("/");
  lcd.setCursor(6, 0);
  lcd.print(RTC.getYear()); // You can make spaces using well... spaces  
  lcd.setCursor(1, 1);
  if(RTC.getHours()<10){
  lcd.print("0");
  lcd.print(RTC.getHours());
  }
  else {
  lcd.print(RTC.getHours());
  }
  
  lcd.print(":");
  if(RTC.getMinutes()<10){
  lcd.print("0");    
  lcd.print(RTC.getMinutes());
  }
  else {
  lcd.print(RTC.getMinutes());  
  }
  lcd.print(":");  
  if(RTC.getSeconds()<10){
  lcd.print("0");  
  lcd.print(RTC.getSeconds());  
  } else {
  lcd.print(RTC.getSeconds());
  }
  
  lcd.print(" ");
  
 
  
  delay(1000);
  // BACKLIGHT FUNCTION TURNED OFF
  //lcd.clear();
  // lcd.backlight();
       // delay(5);
  //lcd.noBacklight();
  //WHEN QUIT BUTTON PRESSED CLOCK 
  while ((sensorVal4) == LOW )
      {
      //lcd.clear() ; 
      //lcd.setCursor(3, 0);
      //lcd.print("UP+DN CLOCK"); // You can make spaces using well... spaces
      ///lcd.setCursor(3, 1); // Or setting the cursor in the desired position.
      //lcd.print("MENU TO ADJ"); 
      //delay(1000);
        loop();
      }

}




